# Description
This project could scan files under the specific directory and run tests in them. The test report could be print to the terminal or pass to the caller via Callback.

Or you could setup only mode to only run all tests or specific tests a specific file.

# How to use it
To run it, you first need to write test. 

You could write test by yourself or use the test template and config to setup tests. Either way require the test functions to be exported and having a callback function as their parameter which will callback(testResult[, errorMessage]).

For example (Write by yourself, it also require chalk.)
```javascript
const chalk = require('chalk')

module.exports = {
    foo
}

function foo(callback) {
    if (1 + 1 === 2) {
        console.log(chalk.green('Test foo passed'))
        callback(true)
    } else {
        console.log(chalk.red('Test foo failed due to '), 'impossible')
        callback(false, 'error message')
    }
}
```

Or you could use test template and config, 
```javascript
module.exports = {
    foo2,
}

const { TestFunctionConfig, readConfigAndRun } = require('jupyter-js-auto-test')

// in most case, this obj should be the object about to test
const obj = {
    foo2: (callback) => {
        if (1 + 1 === 2) {
            console.log("Object run foo2")
            callback(null)
        } else {
            console.log("Object run foo2")
            callback("impossible")
        }
        
    }
}

function foo2(callback) {
    readConfigAndRun(
        new TestFunctionConfig(obj, 'foo2', [], null),
        callback
    )
}
```

More Config examples
```javascript
// having prerunfuncs
new TestFunctionConfig(
            UserLoyaltyLevels,
            'getLevel',
            [level.LevelID],
            null,
            [new TestFunctionConfig(UserLoyaltyLevels, 'addLevel', [level.LevelID, level], null)]
        )
```

Once you have your test functions, you can run it.
```javascript
const { setAndRun } = require('jupyter-js-auto-test')
setAndRun('path/to/directory')
```

If you have any problems or anything to say, please create an issue at github respo, https://github.com/Jupiter0806/JS_Playground/tree/master/my_node_modules/jupyter-js-auto-test
I will try to reply as soon as possible.